
(function () {
	function _setOpen(wgt, open, opts) {
		var colps = wgt.getCollapse();
		if (!colps || 'none' == colps) return; 

		var isVertical = wgt.isVertical(),
			Splitpane = wgt.$class,
			before = colps == 'before',
			caveDom = before ? Splitpane._prev(wgt) : Splitpane._next(wgt),
			caveDom2 = before ? Splitpane._next(wgt) : Splitpane._prev(wgt),
			caveWgt = zk.Widget.$(caveDom.firstChild),
			dimStr = isVertical ? 'height' : 'width',
			cfds = 'client' + dimStr.charAt(0).toUpperCase() + dimStr.slice(1),
			ofds = 'offset' + dimStr.charAt(0).toUpperCase() + dimStr.slice(1),
			maxSize = wgt.$n()[cfds] - wgt.$n('splitter')[ofds],
			newPsd, newNsd;

		if (caveDom && caveDom2) {
			if (!open) {
				var spOffset = zk(wgt.$n('splitter')).cmOffset();
				jq(caveDom).hide();
				zWatch.fireDown('onHide', caveWgt);
				caveDom2.style[dimStr] = jq.px0(maxSize);
				var spOffset1 = zk(wgt.$n('splitter')).cmOffset(); 
				wgt._collapseDiff = isVertical ? (spOffset1[1] - spOffset[1]) : (spOffset1[0] - spOffset[0]);
			} else {
				jq(caveDom).show();
				var lastDiff = wgt._collapseDiff;
				caveDom2.style[dimStr] = jq.px0(maxSize - Math.abs(lastDiff));
				wgt._collapseDiff = 0;
			}
		}

		if (caveDom && open)
			zUtl.fireShown(caveWgt);
		if (caveDom2)
			zUtl.fireSized(zk.Widget.$(caveDom2.firstChild), -1); 

		wgt._fixbtn();

		if (!opts || opts.sendOnOpen)
			wgt.fire('onOpen', {open: open});
			


		wgt.fireOnSplitterMove();
	}

splitpane.Splitpane = zk.$extends(zul.Widget, {
	_orient: 'vertical',
    _collapse: 'none',
	_open: true,
	_resizable: true,

    $init: function() {
		this.$supers('$init', arguments);
	},
	
	$define: {
		
		
		open: function (open, opts) {
			if (this.desktop)
				_setOpen(this, open, opts);
		},
		
		
		orient: null,
		
		
		resizable: function (val) {
			if (this.desktop)
				this._fixResizeIcon();
		},
		
		
		widths: function (val) {
			if (this.desktop)
				this._fixCaveSize();
		},
		
		
		heights: function (val) {
			if (this.desktop)
				this._fixCaveSize();
		},
		
		
		minWidths: function (val) {
			if (this.desktop)
				this._reCalMinDims();
		},
		
		
		minHeights: function (val) {
			if (this.desktop)
				this._reCalMinDims();
		}
	},

	
	getCollapse: function () {
		return this._collapse;
	},
	
	setCollapse: function (collapse) {
		if (this._collapse != collapse) {
			var bOpen = this._open;
			if (!bOpen)
				this.setOpen(true, {sendOnOpen: false});

			this._collapse = collapse;
			if (this.desktop) {
				this._fixbtn();
				this._fixsz();
			}

			if (!bOpen && 'none' != collapse)
				this.setOpen(false, {sendOnOpen: false});
		}
	},
	
	isVertical: function () {
		return 'vertical' == this.getOrient();
	},

	insertChildHTML_: function (child, before, desktop) {
		var caves = this._getCaves();
			$fcv = jq(caves[0]),
			$lcv = jq(caves[1]),
			$sp = jq(this.$n('splitter'));
			html = child.redrawHTML_();

		if (before) {
			$lcv.append(before.$n());
			$fcv.append(html);
			$lcv.show();
			$sp.show();
		} else {
			if (child != this.firstChild) {
				$lcv.html(html);
				$lcv.show();
				$sp.show();
			} else {
				$fcv.html(html);
				$fcv.show();
			}
		}
		child.bind(desktop);
	},

	onChildAdded_: function (child) {
		this.$supers('onChildAdded_', arguments);
		if (this.desktop)
			this._shallSize = true;
	},

	onChildRemoved_: function () {
		this.$supers('onChildRemoved_', arguments);
		if (this.desktop)
			this._shallSize = true;
	},

	removeChildHTML_: function (child) {
		var cave = child.$n().parentNode;
		this.$supers('removeChildHTML_', arguments);
		jq(cave).hide();
		jq(this.$n('splitter')).hide();
	},

	bind_: function() {
		this.$supers(splitpane.Splitpane, 'bind_', arguments);
        zWatch.listen({
			onSize: this, 
			onResponse: this
		});
		this._fixCaveSize(true);
		this._reCalMinDims();
		var node = this.$n(),
			Splitpane = this.$class;
		jq(this.$n('splitter-btn')).click(Splitpane.onBtnClick);
		this._fixbtn();
		this._fixResizeIcon();
		this._drag = new zk.Draggable(this, this.$n('splitter'), {
			constraint: this.getOrient(),
			ignoredrag: Splitpane._ignoresizing,
			ghosting: Splitpane._ghostsizing,
			overlay: true,
			zIndex: 12000,
			initSensitivity: 0,
			snap: Splitpane._snap,
			endeffect: Splitpane._endDrag});

	},
	
	unbind_: function() {
		zWatch.unlisten({
			onSize: this, 
			onResponse: this
		});
		var Splitpane = this.$class,
			btn;
		if (btn = this.$n('splitter-btn')) {
			var $btn = jq(btn);
			$btn.unbind('click', Splitpane.onBtnClick);
		}
		this._drag.destroy();
		this._drag = null;
		this.$supers(splitpane.Splitpane, 'unbind_', arguments);
	},
	
	syncSize: function () {
		this._shallSize = false;
		if (this.desktop) {
			
			for (var w = this.firstChild; w; w = w.nextSibling) {
				if (w._nvflex || w._nhflex) {
					zUtl.fireSized(this, -1);
					break;
				}
			}
		}
	},
	onResponse: function () {
		if (this._shallSize) {
			this.syncSize();
			this._fixbtn();
			this._fixsz();
			this._fixResizeIcon();
		}
	},
	setBtnPos_: function (ver) {
		var btn = this.$n('splitter-btn'),
			node = this.$n('splitter');
		if (ver)
			btn.style.marginLeft = jq.px0((node.offsetWidth - btn.offsetWidth) / 2);
		else
			btn.style.marginTop = jq.px0((node.offsetHeight - btn.offsetHeight) / 2);
	},
	_fixsz: function () {
		if (!this.isRealVisible() || !this.desktop) return;
		var isVertical = this.isVertical(),
			spn = this.$n('splitter'),
		 	pn = this.$n(),
		 	pwdt = pn.clientWidth,
		 	phgt = pn.clientHeight;

		if (isVertical) {
			spn.style.width =  jq.px0(pwdt);
			this.setBtnPos_(true);
		} else {
			spn.style.height = jq.px0(phgt);
			this.setBtnPos_();
		}

		if (this._shallClose) { 
			delete this._shallClose;
			_setOpen(this, false, {sendOnOpen: false});
		}

		var oldTotalSz = this._totalSize;
		this._updateTotalSize();
		var newTotalSz = this._totalSize;

		if (oldTotalSz && oldTotalSz[0] == newTotalSz[0] && oldTotalSz[1] == newTotalSz[1]) return;

		
		var fcwgt = this.firstChild,
			lcwgt = fcwgt ? fcwgt.nextSibling : null;

		if (!fcwgt || !lcwgt) return;

		var	fcwgtNode = fcwgt.$n().parentNode,
			lcwgtNode = lcwgt.$n().parentNode,
			doWd = (!fcwgt.getHflex()) && (!lcwgt.getHflex()),
			doHgh = (!fcwgt.getVflex()) && (!lcwgt.getVflex());

		
		var wLimit = newTotalSz[0];
		if (isVertical) {
			fcwgtNode.style.width = jq.px0(wLimit);
			lcwgtNode.style.width = jq.px0(wLimit);
		} else if (doWd && !isVertical) {
			var fofwd = fcwgtNode.offsetWidth,
				wd;
			if (fofwd >= wLimit)
				wd = wLimit;
			else
				wd = fofwd;
			fcwgtNode.style.width = jq.px0(wd);
			wLimit -= wd;
			lcwgtNode.style.width = jq.px0(wLimit);
		}

		
		var hLimit = newTotalSz[1];
		if (!isVertical) {
			fcwgtNode.style.height = jq.px0(hLimit);
			lcwgtNode.style.height = jq.px0(hLimit);
		} else if (doHgh && isVertical) {
			var fofhgh = fcwgtNode.offsetHeight,
				hgh;
			if (fofhgh >= hLimit)
				hgh = hLimit;
			else
				hgh = fofhgh;
			fcwgtNode.style.height = jq.px0(hgh);
			hLimit -= hgh;
			lcwgtNode.style.height = jq.px0(hLimit);
		}
	},

	onSize: function () {
		if (this.desktop) {
			
			if (this._shallCalCaveSize) {
				this._fixCaveSize(false, true);
				this._shallCalCaveSize = false;
				return;
			}
			this._fixsz();
		}
	},
	
	getZclass: function() {
		return this._zclass != null ? this._zclass: 'z-splitpane';
	},

	_fixResizeIcon: function () {
		var isVertical = this.isVertical(),
			zicon = '.z-icon-ellipsis-' + (isVertical ? 'h' : 'v');
		if (this._resizable) {
			jq(zicon).show();
			var cursorStyle = isVertical ? 's-resize' : 'e-resize';
			this.$n('splitter').style.cursor = cursorStyle;
		} else {
			jq(zicon).hide();
			this.$n('splitter').style.cursor = 'default';
		}
	},
	_fixbtn: function () {
		var $btn = jq(this.$n('splitter-btn')),
			$icon = jq(this.$n('splitter-icon')),
			colps = this.getCollapse();
		if (!colps || 'none' == colps) {
			$btn.addClass(this.$s('splitter-button-disabled'));
			$icon.hide();
		} else {
			var before = colps == 'before';
			if (!this._open) before = !before;

			if (this.isVertical()) {
				jq(this.$n('splitter-icon')).removeClass(before ? 'z-icon-caret-down' : 'z-icon-caret-up')
					.addClass(before ? 'z-icon-caret-up' : 'z-icon-caret-down');
			} else {
				jq(this.$n('splitter-icon')).removeClass(before ? 'z-icon-caret-right' : 'z-icon-caret-left')
					.addClass(before ? 'z-icon-caret-left' : 'z-icon-caret-right');
			}
			$btn.removeClass(this.$s('splitter-button-disabled'));
			$icon.show();
		}
	},

	_getCaves: function () {
		var isVertical = this.isVertical(),
			pos1 = isVertical ? 'top' : 'left',
			pos2 = isVertical ? 'bottom' : 'right';
		return [this.$n('cave-' + pos1), this.$n('cave-' + pos2)];
	},

	_fixCaveSize: function (init, afterFlex) {
		var isVertical = this.isVertical(),
			size = isVertical ? this.getHeight() : this.getWidth(),
			flex = size ? -1 : (isVertical ? this.getVflex() : this.getHflex()),
			caveSizes = isVertical ? this._heights : this._widths,
			caves = this._getCaves(),
			ds = isVertical ? 'height' : 'width',
			ofds = 'offset' + (isVertical ? 'Height' : 'Width'),
			spn = this.$n('splitter'),
			spSize = isVertical ? spn.offsetHeight : spn.offsetWidth,
			totalSize = -1;

		if (!caveSizes)
			caveSizes = [null, null];
		else {
			if (caveSizes[0]) caveSizes[0] = parseInt(caveSizes[0]);
			if (caveSizes[1]) caveSizes[1] = parseInt(caveSizes[1]);
		}

		
		if (size > 0 || afterFlex) {
			var $n = zk(this.$n());
			totalSize = (isVertical ? $n.contentHeight() : $n.contentWidth()) - spSize;
			var limit = totalSize,
				index = 0,
				reverse = false;
			if (!caveSizes[0] && caveSizes[1]) {
				index = 1;
				reverse = true;
			}

			
			if (caveSizes[index] && caveSizes[index] > limit) {
				caveSizes[index] = limit;
			} else {
				caveSizes[index] = caves[index][ofds];
			}
			limit -= caveSizes[index];
			if (reverse)
				index--;
			else
				index++;

			
			caveSizes[index] = limit;

			if (!caves[0].style[ds])
				caves[0].style[ds] = jq.px0(caveSizes[0]);
			if (!caves[1].style[ds])
				caves[1].style[ds] = jq.px0(caveSizes[1]);

		} else if (flex == -1) {
			if (!caveSizes[0])
				caveSizes[0] = caves[0][ofds];
			if (!caveSizes[1])
				caveSizes[1] = caves[1][ofds];
			caves[0].style[ds] = jq.px0(caveSizes[0]);
			caves[1].style[ds] = jq.px0(caveSizes[1]);
			totalSize = caveSizes[0] + caveSizes[1];
		} else {
			var isVertical = this.isVertical(),
				cwgt = this.firstChild,
				flag = true;
			for (; cwgt; cwgt = cwgt.nextSibling) {
				var chdFlex = isVertical ? cwgt.getVflex() : cwgt.getHflex();
				if (chdFlex) {
					flag = false;
					break;
				}
			}
			this._shallCalCaveSize = flag;
		}
		if (totalSize != -1)
			this._updateTotalSize();
		if (!init)
			this._shallSize = true;
	},
	_reCalMinDims: function () {
		var isVertical = this.isVertical(),
			minDims = isVertical ? this._minHeights : this._minWidths,
			minDimArr = [0, 0];
		if (minDims) {
			var $n = jq(this.$n()),
				$sp = jq(this.$n('splitter')),
				total = (isVertical ? $n.height() : $n.width());
			total -= (isVertical ? $sp.height() : $sp.width());
			for (var i = 0; i < minDims.length; i++) {
				if (minDims[i]) {
					if (minDims[i].includes('%'))
						minDimArr[i] = total * (parseInt(minDims[i]) / 100);
					else if (minDims[i].includes('px'))
						minDimArr[i] = parseInt(minDims[i]);
				}
			}
		}
		this._minDims = minDimArr;
	},
	_updateTotalSize: function () {
		var isVertical = this.isVertical();
			spn = this.$n('splitter'),
			spSize = isVertical ? spn.offsetHeight : spn.offsetWidth,
			$n = zk(this.$n()),
			contentW = $n.contentWidth() - (isVertical ? 0 : spSize);
			contentH = $n.contentHeight() - (isVertical ? spSize : 0);

		this._totalSize = [contentW, contentH];
	},
	resetSize_: function (orient) { 
		this.$supers(splitpane.Splitpane, 'resetSize_', arguments);
		var vert = this.isVertical();
		for (var kid = this.firstChild; kid; kid = kid.nextSibling) {
			if (vert ? (kid._nvflex && kid.getVflex() != 'min')
					: (kid._nhflex && kid.getHflex() != 'min')) {
				var chdex = kid.$n().parentNode;
				if (chdex) {
					if (orient == 'h')
						chdex.style.height = '';
					if (orient == 'w')
						chdex.style.width = '';
				}
			}
		}
	},
	getChildMinSize_: function (attr, wgt) { 
		var el = wgt.$n();
		
		
		if (attr == 'w' && wgt._hflex && this.isVertical()) {
			for (var w = wgt.nextSibling, max = 0, width; w; w = w.nextSibling) {
				if (!w._hflex) {
					width = zjq.minWidth(w.$n());
					max = width > max ? width : max;
				}
			}
			return max;
		}
		if (attr == 'h') { 
			return zk(el.parentNode).contentHeight();
		} else {
			return zjq.minWidth(el);
		}
	},
	getContentEdgeHeight_: function () {
		var h = 0;
		for (var kid = this.firstChild; kid; kid = kid.nextSibling)
			h += zk(kid.$n().parentNode).paddingHeight();
		return h;
	},
	getContentEdgeWidth_: function () {
		var w = 0;
		for (var kid = this.firstChild; kid; kid = kid.nextSibling)
			w += zk(kid.$n().parentNode).paddingWidth();
		return w;
	},
	beforeChildrenFlex_: function (child) {
		
		this._shallSize = false;
		child._flexFixed = true;

		var	vert = this.isVertical(),
			vflexs = [],
			vflexsz = vert ? 0 : 1,
			hflexs = [],
			hflexsz = !vert ? 0 : 1,
			p = this.$n(),
			psz = child.getParentSize_(p),
			zkp = zk(p),
			hgh = psz.height - (vert ? this.$n('splitter').offsetHeight : 0),
			wdh = psz.width - (vert ? 0 : this.$n('splitter').offsetWidth),
			xc = this.firstChild,
			scrWdh;

		for (; xc; xc = xc.nextSibling) {
			var zkc;
			if (xc.isVisible() && !(zkc = zk(xc)).hasVParent()) {
				var cwgt = xc,
					c = cwgt.$n(),
					cp = c.parentNode,
					zkxc = zk(cp);
				
				if (xc && xc._nvflex) {
					if (cwgt !== child)
						cwgt._flexFixed = true; 
					if (cwgt._vflex == 'min') {
						cwgt.fixMinFlex_(c, 'h');

						var h = c.offsetHeight + zkc.marginHeight() + zkxc.padBorderHeight();
						cp.style.height = jq.px0(h);
						if (vert)
							hgh -= cp.offsetHeight + zkxc.marginHeight();
					} else {
						vflexs.push(cwgt);
						if (vert) {
							vflexsz += cwgt._nvflex;
							hgh = hgh - zkxc.marginHeight();
						}
					}
				} else if (vert) {
					var isIssueComp = cwgt.$instanceof(zul.wgt.Label) || cwgt.$instanceof(zul.wgt.Span)
							|| cwgt.$instanceof(zul.wgt.Div) || cwgt.$instanceof(zul.wgt.A);
					hgh -= (isIssueComp && zk.ie > 8 ? 1 : 0) + cp.offsetHeight + zkxc.marginHeight();
				}

				
				if (cwgt && cwgt._nhflex) {
					if (cwgt !== child)
						cwgt._flexFixed = true; 
					if (cwgt._hflex == 'min') {
						cwgt.fixMinFlex_(c, 'w');

						var w = c.offsetWidth + zkc.marginWidth() + zkxc.padBorderWidth();
						cp.style.width = jq.px0(zkxc.revisedWidth(w));
						if (!vert)
							wdh -= cp.offsetWidth + zkxc.marginWidth();
					} else {
						hflexs.push(cwgt);
						if (!vert) {
							hflexsz += cwgt._nhflex;
							wdh = wdh - zkxc.marginWidth();
						}
					}
				} else if (!vert)
					wdh -= cp.offsetWidth + zkxc.marginWidth();
			}
		}

		
		var lastsz = hgh > 0 ? hgh : 0;
		while (vflexs.length > 1) {
			var cwgt = vflexs.shift(),
				vsz = (vert ? (cwgt._nvflex * hgh / vflexsz) : hgh) | 0, 
				offtop = cwgt.$n().offsetTop,
				isz = vsz - ((zk.ie < 11 && offtop > 0) ? (offtop * 2) : 0),
				chdex = cwgt.$n().parentNode,
				minus = zk(chdex).padBorderHeight(),
				isInit = !cwgt.$n().style.height;

			
			cwgt.setFlexSize_({height: isz - minus});
			cwgt._vflexsz = vsz - minus;

			
			chdex.style.height = jq.px0(vsz);
			if (vert) lastsz -= vsz;
			if (!isInit && vert && cwgt !== child)
				zUtl.fireSized(cwgt);
		}
		
		if (vflexs.length) {
			var cwgt = vflexs.shift(),
				offtop = cwgt.$n().offsetTop,
				isz = lastsz - ((zk.ie < 11 && offtop > 0) ? (offtop * 2) : 0),
				chdex = cwgt.$n().parentNode,
				minus = zk(chdex).padBorderHeight(),
				isInit = !cwgt.$n().style.height;

			
			cwgt.setFlexSize_({height: isz - minus});
			cwgt._vflexsz = lastsz - minus;

			
			chdex.style.height = jq.px0(lastsz);
			if (!isInit && vert && cwgt !== child)
				zUtl.fireSized(cwgt);
		}
		
		lastsz = wdh > 0 ? wdh : 0;
		while (hflexs.length > 1) {
			var cwgt = hflexs.shift(), 
				hsz = (vert ? wdh : (cwgt._nhflex * wdh / hflexsz)) | 0, 
				chdex = cwgt.$n().parentNode,
				minus = zk(chdex).padBorderWidth(),
				isInit = !cwgt.$n().style.width;

			
			cwgt.setFlexSize_({width: hsz - minus});
			cwgt._hflexsz = hsz - minus;

			
			chdex.style.width = jq.px0(hsz);

			if (!vert) lastsz -= hsz;
			if (!isInit && !vert && cwgt !== child)
				zUtl.fireSized(cwgt);
		}
		
		if (hflexs.length) {
			var cwgt = hflexs.shift(),
				chdex = cwgt.$n().parentNode,
				minus = zk(chdex).padBorderWidth(),
				isInit = !cwgt.$n().style.width;

			
			cwgt.setFlexSize_({width: lastsz - minus});
			cwgt._hflexsz = lastsz - minus;

			
			chdex.style.width = jq.px0(lastsz);
			if (!isInit && !vert && cwgt !== child)
				zUtl.fireSized(cwgt);

		}

		
		child.parent.afterChildrenFlex_(child);
		child._flexFixed = false;
		return false; 
	},
	afterChildrenFlex_: function (opts) {
		this._updateTotalSize();
	},
	afterChildrenMinFlex_: function (opts) {
		var n = this.$n();
		if (opts == 'h') {
			if (this.isVertical_()) {
				var total = 0;
				for (var w = n.firstChild; w; w = w.nextSibling) {
					var fchd = w.firstChild;
					if (fchd.style.height) {
						var hgh = fchd.offsetHeight
								+ zk(w).padBorderHeight()
								+ zk(fchd).marginHeight();
						w.style.height = jq.px0(hgh);
						total += hgh;
					} else
						total += w.offsetHeight;
				}
				n.style.height = jq.px0(total);
			} else {
				var max = 0;
				for (var w = n.firstChild; w; w = w.nextSibling) {
					
					
					var h = w.offsetHeight + zk(w.firstChild).marginHeight();
					if (h > max)
						max = h;
				}
				n.style.height = jq.px0(max);
			}
		} else {
			if (!this.isVertical_()) {
				var total = 0;
				for (var w = n.firstChild; w; w = w.nextSibling) {
					var fchd = w.firstChild;
					if (fchd.style.width) {
						var wdh = fchd.offsetWidth
								+ zk(w).padBorderWidth()
								+ zk(fchd).marginWidth();
						w.style.width = jq.px0(wdh);
						total += wdh;
					} else
						total += w.offsetWidth;
				}

				if ((zk.ie > 8) && this._hflexsz)
					total = Math.max(this._hflexsz, total);

				n.style.width = jq.px0(total);
			} else {
				var max = 0;
				for (var w = n.firstChild; w; w = w.nextSibling) {
					var wd = w.firstChild.offsetWidth + zk(w.firstChild).marginWidth();
					if (wd > max)
						max = wd;
				}
				if ((zk.ie > 8) && this._hflexsz)
					max = Math.max(this._hflexsz, max);
				n.style.width = jq.px0(max);
			}
		}
	},
	fireOnSplitterMove: function() {
		var isVertical = this.isVertical(),
			ofds = 'offset' + (isVertical ? 'Height' : 'Width'),
			Splitpane = this.$class,
			prevDim = Splitpane._prev(this)[ofds],
			nextDim = Splitpane._next(this)[ofds],
			dimStr = jq.px0(prevDim) + ',' + jq.px0(nextDim),
			widths = isVertical ? "" : dimStr,
			heights = isVertical ? dimStr : "";

		this.fire('onDivisionSize', {isVertical: isVertical, widths: widths, heights: heights});
	}

},{
	onBtnClick: function (evt) {
		var wgt = zk.Widget.$(evt);
		wgt.setOpen(!wgt._open);
	},
 	
 	_ignoresizing: function (draggable, pointer, evt) {
 		var wgt = draggable.control;
 		if (!wgt._open || !wgt._resizable || wgt.$n('splitter-icon') == evt.domTarget) return true;
 		var run = draggable.run = {},
 			Splitpane = splitpane.Splitpane;
 		run.prev = Splitpane._prev(wgt);
 		run.next = Splitpane._next(wgt);
 		if (!run.prev || !run.next) return true; 
 		run.prevwgt = wgt.firstChild;
 		run.nextwgt = wgt.lastChild;
 		run.z_offset = zk(draggable.node).cmOffset();
 		return false;
 	},
 	_ghostsizing: function (draggable, ofs, evt) {
 		var $node = zk(draggable.node);
 		jq(document.body).append(
 			'<div id="zk_ddghost" style="font-size:0;line-height:0;background:#AAA;position:absolute;top:'
 			+ ofs[1] + 'px;left:' + ofs[0] + 'px;width:'
 			+ $node.offsetWidth() + 'px;height:' + $node.offsetHeight()
 			+ 'px;"></div>');
 		return jq('#zk_ddghost')[0];
 	},
 	_endDrag: function (draggable) {
 		var wgt = draggable.control,
 			vert = wgt.isVertical(),
 			run = draggable.run,
 			nOffSet = zk(draggable.node).cmOffset(), diff, w, dimStr;

 		if (vert) {
 			diff = run.z_point[1];
 			dimStr = 'height';
 			nOffSet = nOffSet[1];
 		} else {
 			diff = run.z_point[0];
 			dimStr = 'width';
 			nOffSet = nOffSet[0];
 		}
 		if (!diff) return; 

		
		for (var i = 0; i < 2; i++) {
			var w = i == 0 ? run.nextwgt : run.prevwgt;
			if (w) {
				var wn = w.$n();
				if (w.getHflex()) {
					w.setHflex(false);
					wn.style.width = '100%';
				}
				if (w.getVflex()) {
					w.setVflex(false);
					wn.style.height = '100%';
				}
				zWatch.fireDown('beforeSize', w);
			}
		}

 		var runNext = run.next, runPrev = run.prev;
 		if (runNext && runPrev) {
 			var upperDim = dimStr.charAt(0).toUpperCase() + dimStr.slice(1),
 				ofds = 'offset' + upperDim,
 				cfds = 'client' + upperDim,
 				sfds = 'scroll' + upperDim,
 				psfd = zk.parseInt(runPrev[ofds]),
 				nsfd = zk.parseInt(runNext[sfds]),
 				nodeFd = draggable.node[ofds],
 				maxFd = wgt.$n()[cfds];
 			var newPsd = psfd + diff,
 				newNsd = nsfd - diff;
 			if (newPsd < 0) {
 				newNsd += newPsd;
 				newPsd = 0;
 			} else if ((newPsd + nsfd + nodeFd) > maxFd) {
				newNsd = maxFd - newPsd - nodeFd;
				if (newNsd < 0) {
					newPsd = newPsd + newNsd;
					newNsd = 0;
				}
 			}
 			runPrev.style[dimStr] = jq.px0(newPsd);
 			runNext.style[dimStr] = jq.px0(newNsd);
 		}

		zUtl.fireSized(run.prevwgt, -1); 
		zUtl.fireSized(run.nextwgt, -1); 
 		draggable.run = null;
 		wgt.fireOnSplitterMove();
 	},
 	_snap: function (draggable, pos) {
 		var run = draggable.run,
 			wgt = draggable.control,
 			n = wgt.$n(),
 			sp = draggable.node,
 			x = pos[0], y = pos[1],
 			isVertical = wgt.isVertical(),
 			minDim = wgt._minDims;

 		if (isVertical) {
 			var min = run.z_offset[1] - run.prev.offsetHeight + minDim[0];
 			if (y <= min) {
 				y = min;
 			} else {
 				var max = run.z_offset[1] + n.offsetHeight - sp.offsetHeight - run.prev.offsetHeight - minDim[1];
 				if (y > max) y = max;
 			}
 		} else {
 			var min = run.z_offset[0] - run.prev.offsetWidth + minDim[0];
 			if (x <= min) {
 				x = min;
 			} else {
 				var max = run.z_offset[0] + n.offsetWidth - sp.offsetWidth - run.prev.offsetWidth - minDim[1];
 				if (x > max) x = max;
 			}
 		}
 		run.z_point = [x - run.z_offset[0], y - run.z_offset[1]];

 		return [x, y];
 	},
 	_prev: function (wgt) {
 		return wgt.$n('cave-' + (wgt.isVertical() ? 'top' : 'left'));
 	},
 	_next: function (wgt) {
 		return wgt.$n('cave-' + (wgt.isVertical() ? 'bottom' : 'right'));
 	},
 });
})();